// Auto-generated. Do not edit!

// (in-package rc_pick_client.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Rectangle = require('./Rectangle.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class Item {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.uuid = null;
      this.grasp_uuids = null;
      this.rectangle = null;
      this.pose = null;
    }
    else {
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
      if (initObj.hasOwnProperty('grasp_uuids')) {
        this.grasp_uuids = initObj.grasp_uuids
      }
      else {
        this.grasp_uuids = [];
      }
      if (initObj.hasOwnProperty('rectangle')) {
        this.rectangle = initObj.rectangle
      }
      else {
        this.rectangle = new Rectangle();
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type Item
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    // Serialize message field [grasp_uuids]
    bufferOffset = _arraySerializer.string(obj.grasp_uuids, buffer, bufferOffset, null);
    // Serialize message field [rectangle]
    bufferOffset = Rectangle.serialize(obj.rectangle, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type Item
    let len;
    let data = new Item(null);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [grasp_uuids]
    data.grasp_uuids = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [rectangle]
    data.rectangle = Rectangle.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.uuid.length;
    object.grasp_uuids.forEach((val) => {
      length += 4 + val.length;
    });
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    return length + 24;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_pick_client/Item';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '4fb0ba51d2cd2e97771b9b59e87514a4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Definition of an item
    
    # Required
    string uuid
    
    # Optional
    string[] grasp_uuids
    
    # Required
    Rectangle rectangle
    
    # Required. The pose of the item
    geometry_msgs/PoseStamped pose
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new Item(null);
    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    if (msg.grasp_uuids !== undefined) {
      resolved.grasp_uuids = msg.grasp_uuids;
    }
    else {
      resolved.grasp_uuids = []
    }

    if (msg.rectangle !== undefined) {
      resolved.rectangle = Rectangle.Resolve(msg.rectangle)
    }
    else {
      resolved.rectangle = new Rectangle()
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    return resolved;
    }
};

module.exports = Item;
